RE.editor.addEventListener("scroll",(function(){

    var timer = null;

    function _setTime(){
        if(!RE.editor.currentLinkCard){
            return;
        }
        if(timer){
            clearTimeout(timer);
        }
        timer = setTimeout(function(){
            RE.editor.dispathEvent("selectionChange");
        },100);
        
    }

    return _setTime;

    
})());

RE.editor.addEventListener("focus",function(){

        //客户端键盘收起也需要出发该事件
        RE.editor.dispathEvent("selectionChange")
});

RE.editor.addEventListener("touchend", function(e) {
    setTimeout(function(){
        RE.editor.dispathEvent("selectionChange");
    },0)
                           
     // RE.enabledEditingItems();
});

RE.editor.eventBase = {};
RE.editor.currentLinkCard = null;

//临时保存需要获取图片信息的卡片类
RE.editor.tem_linkCards = [];

RE.editor.Selection = new dom.Selection(document,document.getElementsByTagName("body")[0]);
RE.popview.init(document.getElementById("pop_view"));

//通过temid 获取临时数组中是否存在对应linkcard
RE.editor.getlcByTemId = function(temID){
    for(var i =0; i<RE.editor.tem_linkCards.length;i++){
        var tem_id  = RE.editor.tem_linkCards[i].getAttribute("data-id");
        if(tem_id == temID){
            return RE.editor.tem_linkCards[i]
        }
    }
    return false;
}

RE.editor.removeLcByTemId = function(temID){
    for(var i =0; i<RE.editor.tem_linkCards.length;i++){
        var tem_id  = RE.editor.tem_linkCards[i].getAttribute("data-id");
        if(tem_id == temID){
             RE.editor.tem_linkCards.splice(i,1);
        }
    }
}




RE.editor.attachEvent = function(eventName,fn){
    if(typeof this.eventBase[eventName] != "undefined"){
        this.eventBase[eventName].push(fn)
    }else{
        this.eventBase[eventName] = [fn]
    }
}

RE.editor.dispathEvent = function(eventName,args){
    if(!this.eventBase[eventName]){return}
    var event = {
    type:eventName,
    args:args || {}
    }
    
    for(var i=0;i<this.eventBase[event.type].length;i++){
        this.eventBase[eventName][i].call(this,event.args)
    }
}

RE.editor.removeEvent = function(eventName,fn){
    if(this.eventBase[eventName] instanceof Array){
        var i = this.eventBase[eventName].length-1
        for(;i >=0 ; i--){
            this.eventBase[eventName][i] === fn && this.eventBase[eventName].splice(i,1)
        }
    }
}

RE.editor.setlinkcardStatus = function(lc,isfocus){
    if(isfocus){
        $("span.card-content",lc).addClass("card-content-blueborder")
    }else{
        $("span.card-content",lc).removeClass("card-content-blueborder")
    }
        
}

//首次加载内容后，清除所有linkcard-Blueborder
RE.editor.removeAllblueBorder = function(){
    $("span.card-content",RE.editor).removeClass("card-content-blueborder");
}


RE.editor.attachEvent("selectionChange",function(){
          var selection = RE.editor.Selection;
          var linkCard = domUtils.isIncludeLinkCard(selection);
          if(linkCard){

              if(RE.editor.currentLinkCard){
                RE.editor.setlinkcardStatus(RE.editor.currentLinkCard,false)
              }
              
              RE.popview.show(linkCard);
              RE.editor.currentLinkCard = linkCard;
              RE.editor.setlinkcardStatus(linkCard,true);
              domUtils.focusPlaceHolder(linkCard,selection.getRange());

              //禁用编辑器的相关功能
              window.location.href = "editor-disable-status://?"+"status=0"
          }else{
              RE.popview.hide();
              
              if(RE.editor.currentLinkCard){
                RE.editor.setlinkcardStatus(RE.editor.currentLinkCard,false)
              }

              RE.editor.currentLinkCard = null
              //开启编辑器的相关功能
              window.location.href = "editor-disable-status://?"+"status=1"
          }
 });





RE.editor.addEventListener('keydown', function(evt) {
                           var keyCode = evt.keyCode || evt.which;
                           var sel = RE.editor.Selection;
                           var rng = sel.getRange();
                           var startElement = sel.getStart();
                           
                           //修复回车后无法换行问题
                           if (keyCode == 13) {
                               var linkcardNode = domUtils.findParentByTagName(startElement,"a",true);
                               if(linkcardNode) {
                                   evt.preventDefault();
                                   var insertP = domUtils.createNextSiblingsP(sel.getRange(), linkcardNode.parentNode);
                                   rng.setStartAtFirst(insertP);
                                   rng.collapse(true);
                                   rng.setCursor(true);
                                   
                                    setTimeout(function(){
                                        RE.editor.dispathEvent("selectionChange")
                                    },0)
                               }
                           
                           }else if(keyCode == 8){
                           
                           //修复链接标签在整个编辑器为第一个标签时，无法删除问题(凡是a标签，一律一次性删除)
                           var linkcardNode = domUtils.findParentByTagName(startElement,"a",true);
                           if(linkcardNode) {
                               evt.preventDefault();
                               domUtils.remove(linkcardNode);
                               
                               setTimeout(function(){
                                        RE.editor.dispathEvent("selectionChange")
                                },0)
                               return;
                           }
                           
                           //修复在删除链接卡片下一行文字，即将删除到链接卡片时，重新定位光标
                           if(rng.startOffset == 0){
                               var preElement = startElement.previousElementSibling,linkCardNode;
                           if(!preElement){
                            setTimeout(function(){
                                        RE.editor.dispathEvent("selectionChange")
                                },0)
                            return
                            }
                               linkCardNode = $("a.link-card",preElement).get(0)
                           if(linkCardNode){
                               evt.preventDefault();
                               domUtils.focusPlaceHolder(linkCardNode,rng);
                               domUtils.trimWhiteTextNode(linkCardNode);
                               setTimeout(function(){
                                        RE.editor.dispathEvent("selectionChange")
                                },0)
                             }
                            }
                           }else{
                           var linkNode = domUtils.findParentByTagName(startElement,"a",true);
                           if(linkNode){
                                evt.preventDefault();
                                return false;
                               }
                            }
});




RE.editor.attachEvent("changeLinkModel",function(){
                      
                      var sel = RE.editor.Selection;
                      var rng = sel.getRange();
                      var linkcardNode = RE.editor.currentLinkCard;
                      
                      if(linkcardNode){
                          var linkModel = linkcardNode.getAttribute("class");
                          var spacePlaceholderNode = $("span.space-placeholder",linkcardNode).get(0);
                          
                          if(linkModel == "link-card"){
                              linkcardNode.className = "";
                              spacePlaceholderNode.style.display = "none";
                              rng.select(linkcardNode);
                          
                          }else{
                              spacePlaceholderNode.style.display = "inline";
                              linkcardNode.className = "link-card";
                          }
                      
                        RE.editor.dispathEvent("selectionChange");
                      }
});

RE.editor.attachEvent("clearLinkModel",function(){
          var linkcardNode = RE.editor.currentLinkCard;
          if(linkcardNode){
              domUtils.remove(linkcardNode);
              RE.editor.currentLinkCard = null;
              RE.editor.dispathEvent("selectionChange")
          }
});


//editLinkCard
RE.editor.attachEvent("editLinkCard",function(){
        var title =  $(RE.editor.currentLinkCard).find("span.link-text").text();
        var href = $(RE.editor.currentLinkCard).attr("_href") || $(RE.editor.currentLinkCard).find("span.content-link-text").text() || $(RE.editor.currentLinkCard).attr("href");
        var jsonData = {
            "title":title,
            "href":href
        }
        window.location.href = "editor-edit://?"+"title="+ title + "&_href=" + href
});

RE.editLinkCardCallback = function(title,href,imgurl,videoUrl){
    var args = arguments;
    var currentLinkCard = RE.editor.currentLinkCard;
        
        $("span.link-text",currentLinkCard).text(title);
        $("span.content-title",currentLinkCard).text(title);
        $("span.content-link-text",currentLinkCard).text(href);
        
        var temId = currentLinkCard.getAttribute("data-id") || domUtils.createAutoLinkCardId();
        currentLinkCard.setAttribute('data-id',temId);
        RE.editor.tem_linkCards.push(currentLinkCard);

        if(currentLinkCard.getAttribute("_href") != href){
            $("img.article-img",currentLinkCard).attr("src","https://img.imiker.com/editor_yellow_m.png");
            $("img.article-img",currentLinkCard).css({
                width:'6em',
                height:'6em'
            })
            if(imgurl == ""){
                window.location.href = "editor-getImgInfo://?"+"data-id=" + temId + "_&_href=" + href;
            }else{
                RE.getImgInfoCallback(temId,imgurl ? imgurl : "https://img.imiker.com/editor_yellow_m.png");
            }
            if(videoUrl){
                $("img.article-img",currentLinkCard).attr("alt",videoUrl);
                $("img.article-img",currentLinkCard).closest("span").addClass('hasplayicon');
            }else{
                $("img.article-img",currentLinkCard).attr("alt","");
                $("img.article-img",currentLinkCard).closest("span").removeClass('hasplayicon');
            }
            currentLinkCard.setAttribute('_href',href);
            currentLinkCard.setAttribute('href',href);
        }
        
}

RE.getImgInfoCallback = (function(){

        var defaultImgSize = {
            maxwidth:90,
            maxheight:90
        };

       

        //获取图片信息
        function getImgInfo(imgUrl,callback){
            var Img = new Image();
            Img.src = imgUrl;
            Img.onload = function ()
            {
                var imgSize = chageImgSize(Img.width,Img.height);
                callback(imgSize);
            }
        }

        //调整图片尺寸
        function chageImgSize(w,h){
            var myimg = {
                width:w,
                height:h
            }

            if(myimg.width > myimg.height)
            {
                if(myimg.width > defaultImgSize.maxwidth)
                {
                    var oldwidth = myimg.width;
                    myimg.height = myimg.height * (defaultImgSize.maxwidth/oldwidth);
                    myimg.width = defaultImgSize.maxwidth;
                }

            }else{
                if(myimg.height > defaultImgSize.maxheight)
                {
                    var oldheight = myimg.height;
                    myimg.width = myimg.width * (defaultImgSize.maxheight/oldheight);
                    myimg.height = defaultImgSize.maxheight;
                }
            }
            return myimg;
        }

        function _main(temid,imgUrl){
                   var lc = RE.editor.getlcByTemId(temid);
                   if(!lc){return}

                   var ImgBox = $(".article-img",lc);
                   var titleBox = $("span.content-title",lc);

                   function  setImg(imgUrl,hasmixiuImg){
                       getImgInfo(imgUrl,function(imgSize){

                           ImgBox.width(imgSize.width/10 + "em");
                           ImgBox.height(imgSize.height/10 + "em");
                           ImgBox.attr("src",imgUrl);
                           // if(!title){
                           //     titleBox.text(data.title ? data.title : link );
                           // }
                           if(hasmixiuImg){
                               ImgBox.closest("span").addClass('hasplayicon')
                           }else{
                               ImgBox.closest("span").removeClass('hasplayicon')
                           }
                            //TODO:从临时缓存中删除
                           RE.editor.removeLcByTemId(temid);
                       });
                   }
                    setImg(imgUrl,ImgBox.attr("alt") ? true : false)
                   
                   
        }

        return _main;
                  

   
}());



//RE.editor.dispathEvent("selectionChange")
RE.insertLinkCard = (function(){
                     
                     function _insertLinkCard(title,href,imgUrl,videoUrl){
                         var data = {
                            title:title,
                            href:href,
                            videoUrl:videoUrl
                         }
                         var temId = domUtils.createAutoLinkCardId();
                         var lc = new RE.linkCardBase(data);
                         var selection = RE.editor.Selection;
                         var startEle = selection.getStart();
                         var a = document.createElement("a");
                         var range = selection.getRange();
                         //a.setAttribute('href',"javascript:void(0)");
                         a.setAttribute('href',data.href);
                         a.setAttribute('_href',data.href);
                         a.setAttribute('target',"_blank");
                         a.setAttribute("data-id",temId);
                         a.className = 'link-card';
                         a.innerHTML = lc.html;
                     
                         if(!range.collapse){
                            //TODO:选区不闭合禁止插入链接  api
                            return
                         }
                         var pd,eleP,nextSibling;

                        var stringText = RE.editor.innerText.replace(/[\r\n]/g, "")
                         if(range.startContainer.parentElement == RE.editor){
                            pd = range.startContainer
                            eleP =  domUtils.createNextSiblingsP(range,pd);
                         }else if(!stringText){
                            pd = RE.editor;
                            eleP =  domUtils.createNextSiblingsP(range,pd,false);
                         }else{
                             if(startEle.nodeName == "BODY"){
                                pd = RE.editor;
                                eleP =  domUtils.createNextSiblingsP(range,pd,false);
                             }else{
                                 pd = domUtils.getParentDiv(startEle);
                                 eleP =  domUtils.createNextSiblingsP(range,pd);
                             }
                         }

                          var plNode = document.getElementById("placeholder");
                          if(plNode){
                              RE.editor.removeChild(plNode)
                               $(".placeholder-text").remove();
                          }

                         
                         range.insertNode(a);
                         nextSibling = a.nextElementSibling;

                         if(domUtils.isBr(nextSibling)){
                            domUtils.remove(nextSibling);
                         }
                         
                         RE.editor.tem_linkCards.push(a);
                         domUtils.createNextSiblingsP(range, a)
                         if(imgUrl != ''){
                            RE.getImgInfoCallback(temId,imgUrl)
                         }else{
                            window.location.href = "editor-getimginfo://?"+"data-id="+ temId + "_&_href=" + data.href 
                         }
                         
                     }
                     
                     return _insertLinkCard;
                     
}())


//
$(RE.editor).on("click","a",function(){
  return false;
})




//
RE.linkCardBase = (function(){
                   
                   var defaultData = {
                       title:"这个是标题",
                       href:"https://ask.imiker.com",
                       imgUrl:"https://img.imiker.com/editor_yellow_m.png"
                   }
                   
                   
                   function _linkCardBase(data){
                        this.html = this.render(data);
                        this.eventBase = {};
                   }
                   
                   _linkCardBase.prototype = {
                       attachEvent:function(eventName,fn){
                           if(typeof this.eventBase[eventName] != "undefined"){
                           this.eventBase[eventName].push(fn)
                           }else{
                           this.eventBase[eventName] = [fn]
                           }
                       },
                       dispathEvent:function(eventName,args){
                           if(!this.eventBase[eventName]){return}
                           var event = {
                               type:eventName,
                               args:args || {}
                           }
                       
                           for(var i=0;i<this.eventBase[event.type].length;i++){
                             this.eventBase[eventName][i].call(this,event.args)
                           }
                       },
                       removeEvent:function(eventName,fn){
                           if(this.eventBase[eventName] instanceof Array){
                               var i = this.eventBase[eventName].length-1
                                   for(;i >=0 ; i--){
                                   this.eventBase[eventName][i] === fn &&  this.eventBase[eventName].splice(i,1)
                               }
                           }
                       },
                       render:function(data){
                        if(!data){
                             data = defaultData
                         }
                           var html = `<span class="link-text" contenteditable="false">${data.title ? data.title : data.href}</span><span contenteditable="false" class="card-content"><span class="left-content"><span class="content-title" contenteditable="false">${data.title ? data.title : data.href}</span><span class="content-link-text" contenteditable="false">${data.href}</span></span><span class="right-img-content" contenteditable="false"><img width="60" height="60" class="article-img" src="https://img.imiker.com/editor_yellow_m.png" alt="${data.videoUrl ? data.videoUrl : ''}"></span></span><span class="space-placeholder">&#8203;<br></span>`
                           return html
                       }
                   
                   
                   }
                   return _linkCardBase;
                   
}())
