/**
 * Copyright (C) 2017 Wasabeef
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


var cached = true;
var placeholderConst = "请输入您的问题"

RE.currentSelection = {
    "startContainer": 0,
    "startOffset": 0,
    "endContainer": 0,
    "endOffset": 0};

RE.editor = document.getElementById('editor');
RE.firstLine = document.getElementById('first-line');

document.addEventListener("selectionchange", function() {
 RE.backuprange();
 if($(".placeholder-text")){
          if(!!RE.editor.innerHTML){
               RE.insertPlaceholder.check(RE.editor.innerHTML);
            }else{
              RE.insertPlaceholder.init()
            }
 }
 });

// Initializations
RE.callback = function() {
    window.location.href = "re-callback://" + encodeURI(filteLazyloadHtml(RE.getHtml()));
}

RE.setHtml = function(contents) {
    RE.editor.innerHTML = decodeURIComponent(contents.replace(/\+/g, '%20'));
    RE.startloadimg();
}

RE.setGetHeightCallback = function(callback) {
    callback.onGetHeight(RE.editor.scrollHeight);
}

RE.getHtml = function() {
    var pl = document.getElementById("placeholder");
    if(pl){
        return RE.editor.innerHTML.replace(pl.outerHTML, '');
    }
    return RE.editor.innerHTML;
}

RE.getText = function() {
    return RE.editor.innerText;
}

RE.setBaseTextColor = function(color) {
    RE.editor.style.color  = color;
}

RE.setBaseFontSize = function(size) {
    RE.editor.style.fontSize = size;
}

RE.setPadding = function(left, top, right, bottom) {
  RE.editor.style.paddingLeft = left;
  RE.editor.style.paddingTop = top;
  RE.editor.style.paddingRight = right;
  RE.editor.style.paddingBottom = bottom;
}

RE.setBackgroundColor = function(color) {
    document.body.style.backgroundColor = color;
}

RE.setBackgroundImage = function(image) {
    RE.editor.style.backgroundImage = image;
}

RE.setWidth = function(size) {
    RE.editor.style.minWidth = size;
}

RE.setHeight = function(size) {
    RE.editor.style.height = size;
}

RE.setTextAlign = function(align) {
    RE.editor.style.textAlign = align;
}

RE.setVerticalAlign = function(align) {
    RE.editor.style.verticalAlign = align;
}

RE.setPlaceholder = function(placeholder) {
    placeholderConst = placeholder
    if(!RE.editor.innerHTML){
        RE.insertPlaceholder.init();
    }
}

RE.setInputEnabled = function(inputEnabled) {
    RE.editor.contentEditable = String(inputEnabled);
    if(inputEnabled){
        $(RE.editor).css({
            "-webkit-user-modify": "read-write"
        })
//    RE.editor.style.user-modify = "read-write";
    }else{
        $(RE.editor).css({
            "-webkit-user-modify": "read-only"
        })
    //RE.editor.style.user-modify = "read-only";
    }
}

RE.undo = function() {
    document.execCommand('undo', false, null);
    RE.enabledEditingItems();
}

RE.redo = function() {
    document.execCommand('redo', false, null);
    RE.enabledEditingItems();
}

RE.setBold = function() {
    document.execCommand('bold', false, null);
    RE.enabledEditingItems();
}

RE.setItalic = function() {
    document.execCommand('italic', false, null);
    RE.enabledEditingItems();
}

RE.setSubscript = function() {
    document.execCommand('subscript', false, null);
    RE.enabledEditingItems();
}

RE.setSuperscript = function() {
    document.execCommand('superscript', false, null);
    RE.enabledEditingItems();
}

RE.setStrikeThrough = function() {
    document.execCommand('strikeThrough', false, null);
    RE.enabledEditingItems();
}

RE.setUnderline = function() {
    document.execCommand('underline', false, null);
    RE.enabledEditingItems();
}

RE.setBullets = function() {
    document.execCommand('insertUnorderedList', false, null);
    RE.enabledEditingItems();
}

RE.setNumbers = function() {
    document.execCommand('insertOrderedList', false, null);
    RE.enabledEditingItems();
}

RE.setTextColor = function(color) {
    document.execCommand("styleWithCSS", null, true);
    document.execCommand('foreColor', false, color);
    document.execCommand("styleWithCSS", null, false);
    RE.enabledEditingItems();
}

RE.setTextBackgroundColor = function(color) {
    document.execCommand("styleWithCSS", null, true);
    document.execCommand('hiliteColor', false, color);
    document.execCommand("styleWithCSS", null, false);
}

RE.setFontSize = function(fontSize){
    document.execCommand("fontSize", false, fontSize);
}

//RE.setHeading = function(heading) {
//    var range = window.event.srcElement.range;
//    var sel = document.getSelection();
//    document.execCommand('formatBlock', false, '<p style="text-indent:0em;margin:14.5px auto 14.5px auto;">');
//    var el = document.createElement("font");
//    el.setAttribute("style", "font-size:"+ String(21 - heading) + "px;color:#000000;");
////    document.execCommand('formatBlock', false, '<p style="text-indent:0em;margin:14.5px auto 14.5px auto;">');
////    RE.setBold();
////    document.execCommand('insertHTML', false, '<font style="font-size:'+ String(21 - heading) + 'px;color:#000000;">'+ value+'</font>');
////    range.surroundContents(el);
////    var el = document.createElement("a");
////           el.setAttribute("href", url);
////           el.setAttribute("title", title);
////
//           range.surroundContents(el);
//           sel.addRange(range);
//           Re.setBold();
//           Re.callback();
//}

RE.setHeading = function(heading) {
    var plNode = document.getElementById("placeholder");
    if(plNode){
        RE.editor.removeChild(plNode)
         $(".placeholder-text").remove();
    }
    RE.prepareInsert();
    document.execCommand('formatBlock', false, '<h'+heading+'>');
    RE.imikerFilterRules("paragraphlist");
    RE.enabledEditingItems();
}
RE.setIndent = function() {
    document.execCommand('indent', false, null);
    RE.enabledEditingItems();
}

RE.setOutdent = function() {
    document.execCommand('outdent', false, null);
    RE.enabledEditingItems();
}

RE.setJustifyLeft = function() {
    document.execCommand('justifyLeft', false, null);
    RE.enabledEditingItems();
}

RE.setJustifyCenter = function() {
    document.execCommand('justifyCenter', false, null);
    RE.enabledEditingItems();
}

RE.setJustifyRight = function() {
    document.execCommand('justifyRight', false, null);
    RE.enabledEditingItems();
}

RE.setBlockquote = function() {
    document.execCommand('formatBlock', false, '<blockquote>');
    RE.enabledEditingItems();
}

RE.insertImage = function(url) {
    var html;
    var plNode = document.getElementById("placeholder");
    if(plNode){
        RE.editor.removeChild(plNode)
         $(".placeholder-text").remove();
        var textIndent = RE.editor.style.textIndent;
//        html = '<div style=\'text-indent'+textIndent+'\'><br/></div>';
        if(textIndent==''){
        html = '<div ><br/></div>';
        }else{
        html = `<div style="text-indent:${textIndent}"><br/></div>`
        }
    }
        var patt1=new RegExp("@(\\d+)x(\\d+).");
        var result = patt1.exec(url);
        var img_width = result?result[1]:-1;
        var img_height = result?result[2]:-1;
        var wh = parseInt(img_height)/parseInt(img_width);
        wh = wh*100 + "%";
    var imgStr = '<h5 class="img-for-lazyload" style="padding-top:'+wh+'">' + '<img class="real-img lazyload"  src="'+ url +'" data-original="'+ url +'" data-width="'+img_width+'" data-height="'+img_height+'"></h5>';
    if(html){
    html = html + imgStr + '<br></br>';
    }else{
    html = imgStr+'<br></br>';
    }
    RE.backuprange();
    RE.insertHTML(html);
    RE.enabledEditingItems();
}

RE.filterImageSrc = function(){
    $("img.lazyload").attr("src", "https://img.imiker.com/editor_bg.png");
}

RE.insertPlaceholder = (function(){
    var removedCach = false;

    function setCaretPosition(pl, startoffset){
        var selection = getSelection()
        if(selection.anchorNode == pl && selection.anchorOffset==0 && selection.isCollapsed){
            return
        }
        selection.removeAllRanges()
        var range = document.createRange()
        range.selectNodeContents(pl)
        range.setStart(pl,startoffset)
        range.collapse(true)
        selection.addRange(range)
    }
    return {
        setPosition:function(){
                RE.editor.focus();
                var pl = document.getElementById("placeholder");
                setCaretPosition(pl,0)
            },
        init:function(){
                    RE.editor.focus();
                    var node = `<div style="display:inline-block;color:#ccc;word-wrap:break-word;overflow:hidden;disabled:true;" class="placeholder-text" id="placeholder">`+placeholderConst+'</div>';
                    RE.editor.innerHTML  = node;
                    // document.execCommand("insertHTML",false,node);
                    removedCach = false;
                    cached = false;
                    var pl = document.getElementById("placeholder");
                    setCaretPosition(pl,0)
            },
        check:function(currentValue){
            var plNode = document.getElementById("placeholder");
            if(!plNode){
                return
            }
            if(currentValue == `<div style="display:inline-block;color:#ccc;word-wrap:break-word;overflow:hidden;disabled:true;" class="placeholder-text" id="placeholder">`+placeholderConst+`</div>`){
            setCaretPosition(plNode,0);
            return
            }
            if(!removedCach){
//               var text = $(".placeholder-text").text().replace(placeholderConst.replace(/<br>/g,""),'');
               var text = $(".placeholder-text").html().replace(placeholderConst,'');
               if(text.replace(/\s/g,'')==''){
                  RE.editor.innerHTML  = plNode.outerHTML;
                  return
               }
               RE.editor.removeChild(plNode)
                $(".placeholder-text").remove();
               removedCach = true
               cached = true
               document.execCommand("insertHTML",false,text)
            }
        }

    }
})()



RE.first = function(html) {
    RE.firstLine.innerHTML = html;
    var width = RE.firstLine.clientWidth;
    RE.editor.style.textIndent = width + 2+"px";
}

RE.insertImage2 = function(url) {
    RE.insertImage(url);
     var el = new Image();
     el.src = url;
     el.onload = function() {
         if(window.HTMLOUT){
            window.HTMLOUT.getContentWidth(RE.editor.scrollWidth, el.width, el.height);
         }
     }
}

RE.scrollTo = function(height1) {
    window.scrollTo(0,height1);
}

RE.insertHTML = function(html) {
    RE.restorerange();
    document.execCommand('insertHTML', false, html);
}

RE.insertBr = function(html) {
    RE.insertHTML('<p> </p>');
}

RE.appendText = function(text) {
    document.execCommand('insertText', false, text);
}

RE.insertLink = function(url, title) {
    RE.restorerange();
    var sel = document.getSelection();
    if (sel.toString().length == 0) {
        document.execCommand("insertHTML",false,"<a class='link-text' style=\"text-decoration:none;color:#007aff;\" href='"+url+"'>"+title+"&#160;</a>");
    } else if (sel.rangeCount) {
       var el = document.createElement("a");
       el.setAttribute("href", url);
       el.setAttribute("class","link-text");
       el.setAttribute("title", title);
       el.setAttribute("style", "text-decoration:none;color:#007aff;");
       var range = sel.getRangeAt(0).cloneRange();
       range.surroundContents(el);
       sel.removeAllRanges();
       sel.addRange(range);
   }
   //RE.callback()
}

RE.startloadimg = function(){
    // setTimeout(function(){
    //     var img = $("img.lazyload");
    //     img.lazyload({effect: "fadeIn"});
    // },1000)
    // var img = $("img.lazyload");
    // img.lazyload({effect: "fadeIn",threshold: 200});
    $("img.lazyload").each(function(){
        var url = $(this).attr("data-original");
        $(this).attr("src",url);
    })

}

RE.insertAt = function(uid, username) {
    RE.restorerange();
    document.execCommand("insertHTML",false,"<a class='atsomebody' style=\"font-size:16.000000px;color:#2B70C6;\">@"+username+"</a>&nbsp");
    window.currentSelection.focus();
    //RE.callback()
}

RE.setTodo = function(text) {
    var html = '<input type="checkbox" name="'+ text +'" value="'+ text +'"/> &nbsp;';
    document.execCommand('insertHTML', false, html);
}

RE.prepareInsert = function() {
    RE.backuprange();
}

RE.backuprange = function(){
    var selection = window.getSelection();
    if (selection.rangeCount > 0) {
      var range = selection.getRangeAt(0);
      RE.currentSelection = {
          "startContainer": range.startContainer,
          "startOffset": range.startOffset,
          "endContainer": range.endContainer,
          "endOffset": range.endOffset};
    }
}

RE.restorerange = function(){
    var selection = window.getSelection();
    if(selection){
        selection.removeAllRanges();
    }
    var range = document.createRange();
    range.setStart(RE.currentSelection.startContainer, RE.currentSelection.startOffset);
    range.setEnd(RE.currentSelection.endContainer, RE.currentSelection.endOffset);
    selection.addRange(range);
}

RE.enabledEditingItems = function() {
    var items = [];
    if (document.queryCommandState('bold')) {
        items.push('bold');
    }
    if (document.queryCommandState('italic')) {
        items.push('italic');
    }
    if (document.queryCommandState('subscript')) {
        items.push('subscript');
    }
    if (document.queryCommandState('superscript')) {
        items.push('superscript');
    }
    if (document.queryCommandState('strikeThrough')) {
        items.push('strikeThrough');
    }
    if (document.queryCommandState('underline')) {
        items.push('underline');
    }
    if (document.queryCommandState('insertOrderedList')) {
        items.push('orderedList');
    }
    if (document.queryCommandState('insertUnorderedList')) {
        items.push('unorderedList');
    }
    if (document.queryCommandState('justifyCenter')) {
        items.push('justifyCenter');
    }
    if (document.queryCommandState('justifyFull')) {
        items.push('justifyFull');
    }
    if (document.queryCommandState('justifyLeft')) {
        items.push('justifyLeft');
    }
    if (document.queryCommandState('justifyRight')) {
        items.push('justifyRight');
    }
    if (document.queryCommandState('insertHorizontalRule')) {
        items.push('horizontalRule');
    }
    var formatBlock = document.queryCommandValue('formatBlock');
    var textColor = document.queryCommandValue('foreColor').replace(/\s/g, '');
    if(textColor=='rgb(0,0,0)' ){
        items.push('black');
    }else if(textColor=='rgb(239,94,52)'){
        items.push('orange');
    }else if(textColor=='rgb(28,176,146)'){
        items.push('cyan');
    }else if(textColor=='rgb(69,78,174)'){
        items.push('blue');
    }else if(textColor=='rgb(199,195,187)'){
        items.push('grey');
    }else if(textColor=='rgb(51,51,51)'){
        items.push('black');
    }
    if (formatBlock.length > 0) {
        items.push(formatBlock);
    }

    window.location.href = "re-state://state?" + encodeURI(items.join('&'));
    if(window.HTMLOUT){
        window.HTMLOUT.onInput();
    }
}

RE.focus = function() {
    var range = document.createRange();
    range.selectNodeContents(RE.editor);
    range.collapse(false);
    var selection = window.getSelection();
    selection.removeAllRanges();
    selection.addRange(range);
    RE.editor.focus();
}

RE.blurFocus = function() {
    RE.editor.blur();
}

RE.removeFormat = function() {
    document.execCommand('removeFormat', false, null);
}

// Event Listeners
RE.editor.addEventListener("input", function(){
    cached = true;
     if(!!RE.editor.innerHTML){
          RE.insertPlaceholder.check(RE.editor.innerHTML);
       }else{
         RE.insertPlaceholder.init()
     }
     if(window.HTMLOUT){
         window.HTMLOUT.onInput();
     }
});

//RE.editor.addEventListener("paste", function(e){
//    console.log(e);
//});

RE.editor.addEventListener("paste", function(e){
    var plNode = document.getElementById("placeholder");
    if(plNode){
        $(".placeholder-text").remove();
    }
});

RE.editor.addEventListener("keyup", function(e) {
    if(e.which == 8){
        RE.dealDelete();
    }
    var KEY_LEFT = 37, KEY_RIGHT = 39
    if (e.which == KEY_LEFT || e.which == KEY_RIGHT||e.which==13) {
        RE.enabledEditingItems();
    }
    if(!!RE.editor.innerHTML){
       RE.insertPlaceholder.check(RE.editor.innerHTML);
    }else{
       RE.insertPlaceholder.init()
    }
});

RE.dealDelete = function(){
                 var sel = RE.editor.Selection;
                 var rng = sel.getRange();
                 var startElement = sel.getStart();

                 //修复删除图片时候，外层style样式嵌套问题
                 var imgWrap = startElement.parentNode;

                 if(imgWrap.tagName.toLowerCase() == "h5" || imgWrap.tagName.toLowerCase() == "div"){

                 var imgWrapClassName = imgWrap.getAttribute("class");


                 if(imgWrapClassName && imgWrapClassName.indexOf("img-for-lazyload") > -1 && domUtils.findChildrenByTageName(imgWrap,"img","lazyload")){

                         var cursorElement = domUtils.createNextSiblingsP(rng,imgWrap);
                         cursorElement.innerHTML = "<br>";

                         rng.setStart(cursorElement,0);
                         rng.setEnd(cursorElement,0);
                         rng.collapse();
                         rng.setCursor();
                         imgWrap.remove();
                         return;
                     }
                 }

                 if(rng.startOffset != 0)return;
                 var preElement = domUtils.getPreDomNode(startElement,false);

                 if(preElement && preElement.tagName && (preElement.tagName.toLowerCase() == "h5" || preElement.tagName.toLowerCase() == "div")){
                 var preElementClassName = preElement.getAttribute("class"),
                           lazyImgElement = domUtils.findChildrenByTageName(preElement,"img","lazyload");

                 if(preElementClassName && preElementClassName.indexOf("img-for-lazyload") > -1 && lazyImgElement){

                         rng.setStart(preElement,1);
                         rng.setEnd(preElement,1);
                         rng.collapse();
                         rng.setCursor();
                         evt.preventDefault();
                         return;
                     }
                 }
                 var sel = RE.editor.Selection;
                                   var rng = sel.getRange();
                                   var startElement = sel.getStart();

                                   //修复删除图片时候，外层style样式嵌套问题
                                   var imgWrap = startElement.parentNode;

                                   if(imgWrap.tagName.toLowerCase() == "h5" || imgWrap.tagName.toLowerCase() == "div"){

                                   var imgWrapClassName = imgWrap.getAttribute("class");


                                   if(imgWrapClassName && imgWrapClassName.indexOf("img-for-lazyload") > -1 && domUtils.findChildrenByTageName(imgWrap,"img","lazyload")){

                                           var cursorElement = domUtils.createNextSiblingsP(rng,imgWrap);
                                           cursorElement.innerHTML = "<br>";

                                           rng.setStart(cursorElement,0);
                                           rng.setEnd(cursorElement,0);
                                           rng.collapse();
                                           rng.setCursor();
                                           imgWrap.remove();
                                           return;
                                       }
                                   }

                                   if(rng.startOffset != 0)return;
                                   var preElement = domUtils.getPreDomNode(startElement,false);

                                   if(preElement && preElement.tagName &&(preElement.tagName.toLowerCase() == "h5" || preElement.tagName.toLowerCase() == "div")){
                                   var preElementClassName = preElement.getAttribute("class"),
                                             lazyImgElement = domUtils.findChildrenByTageName(preElement,"img","lazyload");

                                   if(preElementClassName && preElementClassName.indexOf("img-for-lazyload") > -1 && lazyImgElement){

                                           rng.setStart(preElement,1);
                                           rng.setEnd(preElement,1);
                                           rng.collapse();
                                           rng.setCursor();
                                           evt.preventDefault();
                                           return;
                                       }
                                   }
}

RE.editor.addEventListener("click", function(e) {
    RE.editor.focus();
    RE.enabledEditingItems();
});


RE.getCurrentSelectionAllStatus = function(){
    return {
    strikethrough: document.queryCommandValue('strikethrough'),
    bold:document.queryCommandState('bold'),
    justifyLeft:document.queryCommandValue('justifyLeft'),
    justifyCenter:document.queryCommandValue('justifyCenter'),
    formatBlock:document.queryCommandValue('formatBlock'),
    insertorderedlist:document.queryCommandValue('insertorderedlist'),
    insertunorderedlist:document.queryCommandValue('insertunorderedlist')
    }
}

RE.imikerFilterRules = function(cmdName,allValue){
    if(!allValue){
        allValue = RE.getCurrentSelectionAllStatus()
    }
    function getChildren(curEle,tagName){
        var nodeList = curEle.childNodes;
        var ary = [];
        if(/MSIE(6|7|8)/.test(navigator.userAgent)){
            for(var i=0;i<nodeList.length;i++){
                var curNode = nodeList[i];
                if(curNode.nodeType ===1){
                    ary[ary.length] = curNode;
                }
            }
        }else{
            ary = Array.prototype.slice.call(curEle.children);
        }

        // 获取指定子元素
        if(typeof tagName === "string"){
            for(var k=0;k<ary.length;k++){
                curTag = ary[k];
                if(curTag.nodeName.toLowerCase() !== tagName.toLowerCase()){
                    ary.splice(k,1);
                    k--;
                }
            }
        }

        return ary;
    }

    //重置对齐方式
    function resetJustify(){

        var st = window.getSelection().anchorNode.parentNode;
        if(allValue.formatBlock == 'h1' || allValue.formatBlock == 'h2'){
            parentsTags.push(allValue.formatBlock)
            $(st).closest(allValue.formatBlock).css("textAlign","left")
            return
        }
        if(allValue.insertorderedlist == "true"){
            $(st).closest("ol").css("textAlign","left")
            return
        }

        if(allValue.insertunorderedlist == "true"){
            $(st).closest("ul").css("textAlign","left")
            return
        }
        if($(st).closest("div")){
            $(st).closest("div").css("textAlign","left")
        }

    }

    //清除段落样式
    function clearparagraphStyle(){
        var sel = window.getSelection();
        var st = sel.anchorNode.parentNode;
        var paragraphString = allValue.formatBlock
        var node =  $(st).closest(paragraphString)[0]
        var childHtml = node.innerHTML;
        var p = document.createElement("div")
        var range = document.createRange();
        p.innerHTML = childHtml;
        $(node).after(p);
        $(node).remove();
        range.selectNode(p);
        sel.removeAllRanges();
        sel.addRange(range);
        sel.collapseToEnd();
        RE.backuprange();
    }

    //清除排序或无序样式
    function clearInsertlist(){

        var st = window.getSelection().anchorNode.parentNode;

        function replaceElement(el){
            var parent = $(st).closest(el)[0]

            var childs = getChildren(parent,'li');
            for(var i=childs.length-1;i>=0;i--){
                var p = document.createElement("div")
                $(p).html(childs[i].innerHTML)
                $(parent).after(p)
            }
            $(parent).remove()
        }
        if(allValue.insertorderedlist == "true"){
//            replaceElement("ol")
            RE.setNumbers();
        }
        if(allValue.insertunorderedlist == "true"){
//            replaceElement("ul")
            RE.setBullets();
        }
    }

    switch(cmdName){
            //有序、无序列表
            case "paragraphlist":
                 clearInsertlist.call(this);
                 var sel = window.getSelection();
                var range = document.createRange()
                if(range.collapse){
                    var st = window.getSelection().anchorNode;
                    var parentNode = $(st).closest("h1");
                    if(parentNode.length == 0){
                        parentNode = $(st).closest("h2");
                    }
                    if(parentNode.length > 0){
                        range.selectNode(parentNode[0])
                        sel.removeAllRanges();
                        sel.addRange(range);
                    }
                }
                 document.execCommand("removeformat");
                 sel.collapseToEnd()
                 break;
            //居中
            case "justifyCenter":
                resetJustify.call(this)
                break;
            //标题h1、h2
             case "formatBlock":
                 if(allValue.formatBlock == 'h1' || allValue.formatBlock == 'h2' || allValue.formatBlock == 'h3'||allValue.formatBlock == 'h4'){
                     clearparagraphStyle.call(this)
                     document.execCommand("removeformat");
                 }
                 break;
    }

}

class FilterSubmitHtmlString {
  constructor(initialHtmlString){
    this.ImgForLazyloadH5ClassName = ".img-for-lazyload";
    this.ImgLazyLoadClassName  = "img.lazyload";
    this.initialHtmlString = initialHtmlString;
    this.counter = 0;

  }

  filteString(){
    this.initWrapNode().filteImgForLazyloadH5().filteLoazyLoadImg().moveOtherNodes();
  }

   initWrapNode(){
    this.wrapNode = document.createElement("div");
    this.wrapNode.innerHTML = this.initialHtmlString;
    return this;
  }

  filteImgForLazyloadH5(){
    const _self = this;
    $(this.ImgForLazyloadH5ClassName,this.wrapNode).each(function(){
      var _this = $(this);
      if(_this.html() == ""){
          _this.remove();
          return;
      }
      if(_this.find(_self.ImgLazyLoadClassName).length == 0){
          _this.css({
              paddingTop:0,
              height:"auto",
              width:"auto"
          });
          _this.removeClass("img-for-lazyload");
          _this.removeClass("delete");
      }
    })
    return _self;
  }


  filteLoazyLoadImg(){
    const _self = this;

    $(this.ImgLazyLoadClassName,this.wrapNode).each(function(){
      _self.counter++;
      var lazyImgWrap = $(this).closest(_self.ImgForLazyloadH5ClassName);
      if(lazyImgWrap.length == 0){
          var curruntParent = $(this).parent();
          var newParent = document.createElement("h5");

          $(newParent).addClass("img-for-lazyload");
          var paddingTop = $(this).attr("data-paddingtop");
          if(!paddingTop)return;
          $(newParent).css({
              paddingTop:paddingTop+"%"
          });
          $(newParent).append(this);
          curruntParent.after(newParent);
      }

      $(this).attr("src","https://img.imiker.com/editor_bg.png");
    });
    return _self;
  }

  moveOtherNodes(){
    const _self = this;
    $(this.ImgLazyLoadClassName,this.wrapNode).each(function(){
       const ele = $(this).get(0);
       const parent  = ele.parentElement;
       let hashandlerImg = false;
       const sblings = parent.childNodes;
       let preP = document.createElement("p");
       let nextP = document.createElement("p");


       for(let i = sblings.length-1; i>=0;i--){

            if(sblings[i] == ele){
              hashandlerImg = true;
              continue;
            }
            if(!hashandlerImg){
              nextP.append(sblings[i])
            }else{
              preP.append(sblings[i])
            }

       }
       preP.childNodes.length > 0 && preP.innerHTML != '\n' &&  $(this).closest(_self.ImgForLazyloadH5ClassName).before(preP);
       nextP.childNodes.length > 0 && nextP.innerHTML != '\n' &&  $(this).closest(_self.ImgForLazyloadH5ClassName).after(nextP);
    });
    return this;
  }

  getFinalHtmlString(){
    this.filteString();
    return this.wrapNode.innerHTML;
  }


}

//提交文章HTML代码时，先调动这个方法过滤Html代码会返回最终过滤后的HTML
function filteLazyloadHtml(hs){
    const f = new FilterSubmitHtmlString(hs);
    return f.getFinalHtmlString();
}
