;(function() {
	if (window.WKWebViewJavascriptBridge) {
		return;
	}

	var messageHandlers = {};
	var responseCallbacks = {};
	var uniqueId = 1;

	function init(messageHandler) {
		if (WKWebViewJavascriptBridge._messageHandler) {
			throw new Error('WKWebViewJavascriptBridge.init called twice');
		}
		WKWebViewJavascriptBridge._messageHandler = messageHandler;
	}

	function send(data, responseCallback) {
		_doSend({ data:data }, responseCallback);
	}

	function registerHandler(handlerName, handler) {
		messageHandlers[handlerName] = handler;
	}

	function callHandler(handlerName, data, responseCallback) {
		_doSend({ handlerName:handlerName, data:data }, responseCallback);
	}

	function _doSend(message, responseCallback) {
		console.log("responseCallback:" + responseCallback);
		if (responseCallback) {
			var callbackId = 'cb_' + (uniqueId++) + '_' + new Date().getTime();
			responseCallbacks[callbackId] = responseCallback;
			message['callbackId'] = callbackId;
		}
		console.log("sending:" + JSON.stringify(message));
/*		_WKWebViewJavascriptBridge._handleMessageFromJs(
			typeof message.data === 'object' ? JSON.stringify(message.data) : (message.data || null),
			message.responseId || null,
			typeof message.responseData === 'object' ? JSON.stringify(message.responseData) : (message.responseData || null),
			message.callbackId || null,
			message.handlerName || null
		);*/
		prompt(JSON.stringify({
                            data: typeof message.data === 'object' ? JSON.stringify(message.data) : (message.data || null),
                            responseId: message.responseId || null,
                            responseData: typeof message.responseData === 'object' ? JSON.stringify(message.responseData) : (message.responseData || null),
                            callbackId: message.callbackId || null,
                            handlerName: message.handlerName || null
                        }));
	}

	function _dispatchMessageFromJava(messageJSON) {
			var message = JSON.parse(messageJSON);
			var messageHandler;

			if (message.responseId) {
				var responseCallback = responseCallbacks[message.responseId];
				if (!responseCallback) { return; }
				responseCallback(message.responseData);
				/*delete responseCallbacks[message.responseId];*/
			} else {
				var responseCallback;
				if (message.callbackId) {
					var callbackResponseId = message.callbackId;
					responseCallback = function(responseData) {
						_doSend({ responseId: callbackResponseId, responseData: responseData });
					};
				}

				var handler;
				if (message.handlerName) {
					handler = messageHandlers[message.handlerName];
				}else if(WKWebViewJavascriptBridge._messageHandler){
                    handler = WKWebViewJavascriptBridge._messageHandler;
                }
				try {
				    if(handler){
					    handler(message.data, responseCallback);
				    }
				} catch(exception) {
					if (typeof console !== 'undefined') {
						console.log("WKWebViewJavascriptBridge: WARNING: javascript handler threw. " + exception.toString() + message);
					}
				}
			}
	}


	function _handleMessageFromJava(messageJSON) {
		_dispatchMessageFromJava(messageJSON);
	}

	/* export */
	window.WKWebViewJavascriptBridge = {
		init: init,
		send: send,
		registerHandler: registerHandler,
		callHandler: callHandler,
		_handleMessageFromJava: _handleMessageFromJava
	};

	/* dispatch event */
	var doc = document;
    var readyEvent = doc.createEvent('Events');
    readyEvent.initEvent('WKWebViewJavascriptBridgeReady');
    readyEvent.bridge = WKWebViewJavascriptBridge;
    doc.dispatchEvent(readyEvent);
})();